#PNAS submission system does not support .py files. 
#To run this script, please change “.txt” to “.py” in the file name 
#This script reduces initial data sets Supplementary Data 1-6 by removing multiple strains per species and by removing mutliple species per genus
import pandas as pd
import sys
# import os

input_file = sys.argv[1] #base filename e.g. LeuRS
# new_file_name = os.path.split(input_file)[-1].split('_reduced_to_species.csv')[-2]
new_file_name = input_file.split('_reduced_to_species.csv')[0]

# new_file_name = input_file.split('_reduced_to_species.csv')[-1]
new_file_name += '_reduced_to_genus.csv'
df = pd.read_csv(input_file)

##
df['OrganismFirstName'] = df['Organism'].apply(lambda x: x.split()[0])
df_new = df.groupby('OrganismFirstName').agg({'Total number of mutations':'max'}).reset_index()
df_new = df_new.merge(df, on=['OrganismFirstName', 'Total number of mutations'], how='left')
df_new.drop_duplicates(subset=['OrganismFirstName', 'Total number of mutations'], keep='first', inplace=True)

df_new = df_new.drop('OrganismFirstName', axis=1)
df_new.to_csv(new_file_name, index=False)
